/*
 * JBoss, Home of Professional Open Source
 * Copyright 2006, JBoss Inc., and others contributors as indicated 
 * by the @authors tag. All rights reserved. 
 * See the copyright.txt in the distribution for a
 * full listing of individual contributors. 
 * This copyrighted material is made available to anyone wishing to use,
 * modify, copy, or redistribute it subject to the terms and conditions
 * of the GNU Lesser General Public License, v. 2.1.
 * This program is distributed in the hope that it will be useful, but WITHOUT A 
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
 * PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.
 * You should have received a copy of the GNU Lesser General Public License,
 * v.2.1 along with this distribution; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
 * MA  02110-1301, USA.
 * 
 * (C) 2005-2006,
 * @author JBoss Inc.
 */
package com.sample.action;

import org.jbpm.graph.def.*;
import org.jbpm.graph.exe.*;
import org.jbpm.*;

public class MyBPMActionHandler implements ActionHandler 
{
	private static final long serialVersionUID = 1L;

	private static long latestPid; // sorry, just a quick test
	
	public void execute(ExecutionContext exCtx) throws Exception 
	{
				
                System.out.println("#%%#### Executed by the process, not by the ESB");
                
		JbpmContext jbpmContext = JbpmContext.getCurrentJbpmContext();
		ProcessDefinition pDef = jbpmContext.getGraphSession()
				.findLatestProcessDefinition("processDefinition2");
		ProcessInstance pi = new ProcessInstance(pDef);
		jbpmContext.save(pi);
                System.out.println("Created ProcessInstance : " + pi.getId());

                long currentPid = exCtx.getProcessInstance().getId();

                //System.out.println(latestPid + " : " + currentPid);

                if (latestPid != currentPid) {
                   // first job execution
                   latestPid = currentPid;
                   jbpmContext.setRollbackOnly();
                   throw new RuntimeException("Rollback, please.");
                }
        
                // success when retry
                latestPid = currentPid;
		exCtx.leaveNode();
	}

}
