package com.sample.ejb;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.ejb.*;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.jbpm.JbpmConfiguration;
import org.jbpm.JbpmContext;
import org.jbpm.db.GraphSession;
import org.jbpm.graph.def.ActionHandler;
import org.jbpm.graph.def.Node;
import org.jbpm.graph.def.ProcessDefinition;
import org.jbpm.graph.exe.ExecutionContext;
import org.jbpm.graph.exe.ProcessInstance;
import org.jbpm.graph.exe.Token;

@Stateless
@Remote
@TransactionManagement(TransactionManagementType.BEAN)
public class SampleImpl implements Sample {
	
  private static final String PROCESS_NAME = "processDefinition2";

  private static final long serialVersionUID = 1L;
  private static Log log = LogFactory.getLog(SampleImpl.class);
	
  public void work() throws Exception {
	
                log.info("## work - begin");

                JbpmConfiguration jbpmConfiguration = JbpmConfiguration.getInstance();
                JbpmContext jbpmContext = null;

                try {
                        jbpmContext = jbpmConfiguration.createJbpmContext();
                        GraphSession session = jbpmContext.getGraphSession();
                        ProcessDefinition processDefinition = session.findLatestProcessDefinition(PROCESS_NAME);
                        ProcessInstance pi = new ProcessInstance(processDefinition);
                        long id = pi.getId();
                        Token token = pi.getRootToken();
                        token.signal();
                } finally {
                        jbpmContext.close();
                }
                log.info("## work - end");

  }
}
